## Erlend april 2014
## covar.r - Script for  lese inn, strukturere, normalisere og skrive filer for kovariabler til ko-kriging(OcK)
## OBS: Scriptet br kjres 2 ganger. En for kun referansefelt til mappen Tau og en med NTE-felt inkludert til mappen Covariables
## Dette er pga scriptet for ko-kriging
setwd("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/Tau/")
# setwd("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/Covariables/")
library("fields")
library("Kendall")
library(lattice)
rm(list=ls())
graphics.off()
## Lage tabell med FID, koordinater, Cr, Rr, Dd, TWI, WI.
## OBS: WI-data er laget slik 'alfabetisk' det vil si at catch_10 kommer fr catch_2 til catch_9 osv.

atrtab=read.table("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/Alle felt.txt", header=TRUE)
atrtab1=read.table("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/Feltparametre.txt", header=TRUE)
TWI_NTE=read.table("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/Covariables/TWI_NTE-felt.txt", header=TRUE)
TWI_NVE=read.table("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/Covariables/TWI_NVE-felt.txt", header=TRUE)
TWI=rbind(TWI_NTE,TWI_NVE)
WI=read.table("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/Covariables/WI.txt")

Cr=(atrtab[,3])/(atrtab[,4])
Rr=(atrtab1[,8]/atrtab[,4])
Dd=(atrtab1[,12])
Dd[Dd==0]=NA
TWI=(TWI[,6])
# M fikse rekkeflgen p WI-data
WI_rev=c(WI[1:2,2],WI[13,2],WI[24,2],WI[35,2],WI[44:48,2],WI[3:12,2],WI[14:23,2],WI[25:34,2],WI[36:43,2])
WI=(WI_rev)

# Binder alle variablene sammen i en tabell
covar=cbind(atrtab[,1], atrtab[,7], atrtab[,8], Cr, Rr, Dd, TWI, WI)


####################################################
## Normalisere ko-variablene iht ordinr ko-kriging
Cr_Norm=(Cr-min(Cr))/((max(Cr))-(min(Cr)))
Rr_Norm=(Rr-min(Rr))/((max(Rr))-(min(Rr)))
Dd_Norm=(Dd-min(Dd, na.rm=TRUE))/((max(Dd, na.rm=TRUE))-(min(Dd, na.rm=TRUE)))
TWI_Norm=(TWI-min(TWI))/((max(TWI))-(min(TWI)))
WI_Norm=(WI-min(WI))/((max(WI))-(min(WI)))

covar_norm=cbind(atrtab[,1], atrtab[,7], atrtab[,8], Cr_Norm, Rr_Norm, Dd_Norm, TWI_Norm, WI_Norm)

#output <- "covar.txt"
#fout<- file(output, "w")
#output1 <- "covar_norm.txt"
#fout1 <- file(output1, "w")

#write.table(covar,file=fout, quote = F, col.names = c("FID", "x","y","Cr","Rr","Dd","TWI","WI"),row.names =F, sep=",")
#write.table(covar_norm, file=fout1, quote = F, col.names = c("FID", "x","y","Cr","Rr","Dd","TWI","WI"),row.names =F, sep=",")


output <- ("Euclidean_dist.txt")
fout<- file(output, "w")

nr_felt <- 48
for (i in 1:nr_felt){
  dist_1 <- covar[i,2:3]
  for (j in 1:nr_felt){
    dist_2 <- covar[j,2:3]
    rdist <- dist(rbind(dist_1, dist_2), method="euclidean")
    
    cat(paste(c(i,j,round(rdist,digit =3))),file =fout, sep=",")
    
    cat("\n",file=fout)
    
  }
}
close(fout)

output1 <- "Simcoeff_cov.txt"
fout1 <- file(output1, "w")

nr_felt <- 48
for (ii in 1:nr_felt){
  cov_1 <- covar_norm[ii,4:8]

  for (jj in 1:nr_felt){
    cov_2 <- covar_norm[jj,4:8]
    
    #
    SimCoeff <- 1- abs((cov_1 - cov_2))
    
    
    cat(paste(c((ii),(jj), round(SimCoeff,digits = 3))),file =fout1, sep=",")
    
    
    cat("\n",file=fout1)
    
  }
}
#
close(fout1)

# Leser inn tabell med distanse for alle felt
dist <- read.table("Euclidean_dist.txt",sep=",")

# Leser inn tabell med tau. Denne har verdi kun for ref-feltene.
corr <- read.table("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/dist_corr/rdist_corr_updated.txt",header=TRUE,sep = ",")
corr=cbind(corr[,1:2],corr[,4])
# M derfor sette inn NA-verdier for alle NTE-feltene i en litt komplisert og udelikat operasjon:

final=matrix(nrow=13, ncol=3)
colnames(final)=colnames(corr)
na.i=matrix(nrow=13, ncol=3)
colnames(na.i)=colnames(corr)
for(i in seq(1,1225,35)){
  corr.i=corr[i:(i+34),]
  corr1=rbind(corr.i, na.i)
  final=rbind(final, corr1)
}
no_corr=matrix(nrow=(13*48), ncol=3)
colnames(no_corr)=colnames(corr)
corr=rbind(no_corr, final)
corr=corr[1:2304,]
corr=as.data.frame(corr)

# Simcoeff for alle ko-variable
cov <- read.table("Simcoeff_cov.txt",header = FALSE,sep=",")
fout3 <- cbind(dist[,1:3],corr[,3], cov[,3:7])
write.table(fout3,"Euclidean_cov_corr.txt", quote = F, col.names = c("Ref_Catch", "Corr_Catch","Dist.","CORR","SimCoeff.Cr","Rr","Dd","TWI","WI"),row.names =F, sep=",")

# Strukturere alle data for ko-kriging ved  skrive til enkelte filer for hvert felt:
plot_data <-read.table("Euclidean_cov_corr.txt",header = T, sep =",")
coords <- covar[1:48,2:3] #read.table("C:/Users/Erlend/Documents/NTNU/Prosjektoppgave/kartdata/Catch_corr/Catch_1",header = T, sep ="")

for(i in seq(1,48,1)){
  gauge.i <- i
  fout5 <- file(paste("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/Covariables/","tar_catch_",gauge.i,sep=""),"w")
  sel <- plot_data$Ref_Catch == (gauge.i)
  #plot_data1 <- plot_data[sel,] # for plotting
  plot_data2 <- plot_data[sel,4:9] # for geoR input
  count <- seq(1,48,1)
  write.table(cbind(count, coords[,1:2],plot_data2),fout5,quote = F,
              col.names = c("","x","y","CORR","SimCoeff.Cr","Rr","Dd","TWI","WI"),row.names =F, sep=",")
  
  close(fout5)
}