# Mulugeta, October 2010
# ---------------------------------------------------------------------------
# Topo_index.py
# Created on: ti feb 15 2011 05:01:36 
#   (generated by ArcGIS/ModelBuilder)
# Usage: Topo_index <TOPIDX_OUTPUT> <DEM> <Cell_Area> <Z_limit> <Area_Threshold> 
# ---------------------------------------------------------------------------
# 
# Import system modules
import sys, string, os, arcgisscripting

# Create the Geoprocessor object
gp = arcgisscripting.create()

# Check out any necessary licenses
gp.CheckOutExtension("spatial")

# Load required toolboxes...
gp.AddToolbox("C:\Program Files (x86)\ArcGIS\Desktop10.0\ArcToolbox\Toolboxes\Spatial Analyst Tools.tbx")

# Script arguments...
TOPIDX_OUTPUT = sys.argv[1]
if TOPIDX_OUTPUT == '#':
 TOPIDX_OUTPUT = "C:\Users\Erlend\Documents\NTNU\Masteroppgave\TWI" # provide a default value if unspecified

DEM = sys.argv[2]
if DEM == '#':
 DEM = "lower1_fel" # provide a default value if unspecified

Cell_Area = sys.argv[3]
if Cell_Area == '#':
 Cell_Area = "625" # provide a default value if unspecified

Z_limit = sys.argv[4]

Area_Threshold = sys.argv[5]
if Area_Threshold == '#':
 Area_Threshold = "1" # provide a default value if unspecified

# Local variables...
Output_surface_raster = "C:\Users\Erlend\Documents\NTNU\Masteroppgave\TWI\Fill_lower1_1"
FlowAcc_Flow1 = "C:\Users\Erlend\Documents\NTNU\Masteroppgave\TWI\FlowAcc_Flow1"
Slope_Fill_l1 = "C:\Users\Erlend\Documents\NTNU\Masteroppgave\TWI\Slope_Fill_l1"
AREA = "C:\Users\Erlend\Documents\NTNU\Masteroppgave\TWI\Times_Plus_F1"
Output_raster = "C:\Users\Erlend\Documents\NTNU\Masteroppgave\TWI\Divide_Times2"
Output_flow_direction_raster = "C:\Users\Erlend\Documents\NTNU\Masteroppgave\TWI\FlowDir_Fill1"
Output_drop_raster = ""
TanB = "C:\Users\Erlend\Documents\NTNU\Masteroppgave\TWI\Tan_Times_Pl1"
Times_Reclas1 = "C:\Users\Erlend\Documents\NTNU\Masteroppgave\TWI\Times_Plus_S1"
Input_raster_or_constant_value_2 = "0.017453"
Plus_Slope_F1 = "C:\Users\Erlend\Documents\NTNU\Masteroppgave\TWI\Plus_Slope_F1"
Input_raster_or_constant_value_2__2_ = "1"
Plus_FlowAcc1 = "C:\Users\Erlend\Documents\NTNU\Masteroppgave\TWI\Plus_FlowAcc1"

# Process: Fill...
gp.Fill_sa(DEM, Output_surface_raster, Z_limit)

# Process: Flow Direction...
gp.FlowDirection_sa(Output_surface_raster, Output_flow_direction_raster, "NORMAL", Output_drop_raster)

# Process: Flow Accumulation...
gp.FlowAccumulation_sa(Output_flow_direction_raster, FlowAcc_Flow1, "", "FLOAT")

# Process: Plus (2)...
gp.Plus_sa(FlowAcc_Flow1, Area_Threshold, Plus_FlowAcc1)

# Process: Times...
gp.Times_sa(Plus_FlowAcc1, Cell_Area, AREA)

# Process: Slope...
gp.Slope_sa(Output_surface_raster, Slope_Fill_l1, "DEGREE", "1")

# Process: Plus...
gp.Plus_sa(Slope_Fill_l1, Input_raster_or_constant_value_2__2_, Plus_Slope_F1)

# Process: Times (2)...
gp.Times_sa(Plus_Slope_F1, Input_raster_or_constant_value_2, Times_Reclas1)

# Process: Tan...
gp.Tan_sa(Times_Reclas1, TanB)

# Process: Divide (2)...
gp.Divide_sa(AREA, TanB, Output_raster)

# Process: Ln...
gp.Ln_sa(Output_raster, TOPIDX_OUTPUT)

