## Erlend Gjestemoen april 2014
## Qdata.r - Et script for  ta inn vannfringsdata sendt fra NVE, redigere og samle alle i en tabell


## Jeg har Qdata som skal brukes videre i fem .csv filer tilsendt fra NVE
## Steg 1: Leser inn .csv-filene fra NVE og gjr om ingen data-verdier til NA i.h.t. R
Qdata1=read.csv(file="C:/Users/Erlend/Documents/NTNU/Prosjektoppgave/reoversiktovermlestasjoner/nord_del1.csv",header=FALSE,skip=20, sep=";", dec=".")
Qdata1[Qdata1==-9999]=NA

Qdata2=read.csv(file="C:/Users/Erlend/Documents/NTNU/Prosjektoppgave/reoversiktovermlestasjoner/nord_del3.csv",header=FALSE,skip=6, sep=";", dec=".")
Qdata2[Qdata2==-9999]=NA

Qdata3=read.csv(file="C:/Users/Erlend/Documents/NTNU/Prosjektoppgave/reoversiktovermlestasjoner/sor_del1.csv",header=FALSE,skip=20, sep=";", dec=".")
Qdata3[Qdata3==-9999]=NA

Qdata4=read.csv(file="C:/Users/Erlend/Documents/NTNU/Prosjektoppgave/reoversiktovermlestasjoner/del1_1710.csv",header=FALSE,skip=20, sep=";", dec=".")
Qdata4[Qdata4==-9999]=NA

Qdata5=read.csv(file="C:/Users/Erlend/Documents/NTNU/Prosjektoppgave/reoversiktovermlestasjoner/del2_1710.csv",header=FALSE,skip=20, sep=";", dec=".")
Qdata5[Qdata5==-9999]=NA

# Steg 2: Dataseriene fra NVE har ulikt spenn. Kontrollere datoene og f dem like lange over samme periode

Qdata1 = Qdata1[-c(1:3287,38718:39082), ]
Qdata3 = Qdata3[-c(1:2922), ]
Qdata4 = Qdata4[-c(1:4749), ]
Qdata5 = Qdata5[-c(1:2191), ]

# Steg 3: Luke ut de interessante seriene og lime sammen til en tabell. 
# (Her m det kontrolleres via .csv filene at de riktige seriene blir valgt)

ref.felt=cbind(Qdata5[,6],Qdata5[,2],Qdata4[,20],Qdata4[,21],Qdata5[,7],Qdata5[,3],Qdata4[,19],Qdata4[,15],Qdata1[,18],Qdata2[,4],Qdata2[,6],Qdata2[,3],Qdata1[,14],Qdata1[,17],Qdata2[,5],Qdata2[,2],Qdata1[,19],Qdata1[,20],Qdata2[,7],Qdata1[,13],Qdata4[,14],Qdata1[,12],Qdata3[,20],Qdata1[,11],Qdata1[,9],Qdata1[,6],Qdata1[,10],Qdata4[,13],Qdata4[,12],Qdata3[,4],Qdata1[,5],Qdata1[,4],Qdata4[,8],Qdata3[,18],Qdata4[,9])

# Steg 4: Redigere serier i henhold til regulering, overfring og visuell inspeksjon

# bjrvatn regulert fra 1979
ref.felt[23012:35430,7]=NA
# Tra regulert etter 24.3.1994
ref.felt[28573:35430,35]=NA
# Mannseter regulert etter 24.3.1994
ref.felt[28573:35430,33]=NA

# Steg 5: Skrive den nye tabellen til en fil p pc for lagring

setwd("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/")
fout="Q_ref_felt.txt"
write.table(ref.felt, file =fout, append = FALSE, quote = FALSE, sep = "\t ", row.names = TRUE,col.names = TRUE, )




########################---FERDIG---##################################


data2=data1[,2:21]
row.names(data2)=as.Date(data1[,1])

for.navn=read.csv(file="C:/Users/Erlend/Documents/NTNU/Prosjektoppgave/reoversiktovermlestasjoner/nord_del1.csv",header=FALSE,sep=";", dec=".")
navn1=for.navn[1:20,]
navn2=as.character(navn1)
names(data2)=navn2
#data_med_navn=rbind(navn1,data1)
# data1 er dermed 20 felt med dgnlige data og radnavn med dato og kolonnenavn beskrivende for feltet
setwd("C:/Users/Erlend/Documents/NTNU/Prosjektoppgave/kartdata/Vannfringsdata/")
fout="del1.txt"

write.table(data2, file =fout, append = FALSE, quote = FALSE, sep = "\t ", row.names = TRUE,col.names = TRUE, )

## Del 3 nord
data3=read.csv(file="C:/Users/Erlend/Documents/NTNU/Prosjektoppgave/reoversiktovermlestasjoner/nord_del3.csv",header=FALSE,skip=6, sep=";", dec=".")
data4=data3[,2:7]
row.names(data4)=as.Date(data3[,1])

for.navn1=read.csv(file="C:/Users/Erlend/Documents/NTNU/Prosjektoppgave/reoversiktovermlestasjoner/nord_del3.csv",header=FALSE,sep=";", dec=".")
navn3=for.navn1[1:6,]
navn4=as.character(navn3)
names(data4)=navn4
#data_med_navn=rbind(navn1,data1)
# data1 er dermed 20 felt med dgnlige data og radnavn med dato og kolonnenavn beskrivende for feltet
setwd("C:/Users/Erlend/Documents/NTNU/Prosjektoppgave/kartdata/Vannfringsdata/")
fout="del3.txt"

write.table(data4, file =fout, append = FALSE, quote = FALSE, sep = "\t ", row.names = TRUE,col.names = TRUE, )

## Del 1 sr
data5=read.csv(file="C:/Users/Erlend/Documents/NTNU/Prosjektoppgave/reoversiktovermlestasjoner/sor_del1.csv",header=FALSE,skip=20, sep=";", dec=".")
data6=data5[,2:21]
row.names(data6)=as.Date(data5[,1])

for.navn2=read.csv(file="C:/Users/Erlend/Documents/NTNU/Prosjektoppgave/reoversiktovermlestasjoner/sor_del1.csv",header=FALSE,sep=";", dec=".")
navn5=for.navn2[1:20,]
navn6=as.character(navn5)
names(data6)=navn6
#data_med_navn=rbind(navn1,data1)
# data1 er dermed 20 felt med dgnlige data og radnavn med dato og kolonnenavn beskrivende for feltet
setwd("C:/Users/Erlend/Documents/NTNU/Prosjektoppgave/kartdata/Vannfringsdata/")
fout="del1_sor.txt"

write.table(data6, file =fout, append = FALSE, quote = FALSE, sep = "\t ", row.names = TRUE,col.names = TRUE, )

## Del 1 1710
data7=read.csv(file="C:/Users/Erlend/Documents/NTNU/Prosjektoppgave/reoversiktovermlestasjoner/del1_1710.csv",header=FALSE,skip=20, sep=";", dec=".")
data8=data7[,2:21]
row.names(data8)=as.Date(data7[,1])

for.navn3=read.csv(file="C:/Users/Erlend/Documents/NTNU/Prosjektoppgave/reoversiktovermlestasjoner/del1_1710.csv",header=FALSE,sep=";", dec=".")
navn7=for.navn3[1:20,]
navn8=as.character(navn7)
names(data8)=navn8
#data_med_navn=rbind(navn1,data1)
# data1 er dermed 20 felt med dgnlige data og radnavn med dato og kolonnenavn beskrivende for feltet
setwd("C:/Users/Erlend/Documents/NTNU/Prosjektoppgave/kartdata/Vannfringsdata/")
fout="del1_1710.txt"

write.table(data8, file =fout, append = FALSE, quote = FALSE, sep = "\t ", row.names = TRUE,col.names = TRUE, )

## Del 2 1710
data9=read.csv(file="C:/Users/Erlend/Documents/NTNU/Prosjektoppgave/reoversiktovermlestasjoner/del2_1710.csv",header=FALSE,skip=20, sep=";", dec=".")
data10=data9[,2:21]
row.names(data10)=as.Date(data9[,1])

for.navn4=read.csv(file="C:/Users/Erlend/Documents/NTNU/Prosjektoppgave/reoversiktovermlestasjoner/del2_1710.csv",header=FALSE,sep=";", dec=".")
navn9=for.navn4[1:20,]
navn10=as.character(navn9)
names(data10)=navn10
#data_med_navn=rbind(navn1,data1)
# data1 er dermed 20 felt med dgnlige data og radnavn med dato og kolonnenavn beskrivende for feltet
setwd("C:/Users/Erlend/Documents/NTNU/Prosjektoppgave/kartdata/Vannfringsdata/")
fout="del2_1710.txt"

write.table(data10, file =fout, append = FALSE, quote = FALSE, sep = "\t ", row.names = TRUE,col.names = TRUE, )


###############################################################################################
# Steg 2: NVE's kode for ingen data er -9999. I R settes de til NA.
data2[data2==-9999] <- NA
data4[data4==-9999] <- NA
data6[data6==-9999] <- NA
data8[data8==-9999] <- NA
data10[data10==-9999] <- NA

# Steg 3: 

data2b <- data2[-c(1:3287,38718:39082), ]
data6b <- data6[-c(1:2922), ]
data8b <- data8[-c(1:4749), ]
data10b <- data10[-c(1:2191), ]

alle.felt=cbind(data2b,data4,data6b,data8b,data10b)

Floan_bru=data.frame(ref.felt[,5:6])
Floan_bru[Floan_bru==-9999] <- 0
Floan_bru[,3]=Floan_bru[,1]+Floan_bru[,2]



ref.felt=allefelt[,-c(1,15,20,27,28,31:42,44,47,49:51,61:63,69,73:86)]



## Sortering i henhold til FID
#dates=row.names[-c(1:3653)]
#Floan_bru=cbind(ref.felt[,5],ref.felt[,6])

# den under gir sorterte referansedelt etter FID, men som matrise uten navn og dato.
ref.felt.FID=cbind(ref.felt[,46],ref.felt[,42],ref.felt[,45],ref.felt[,43],ref.felt[,44],ref.felt[,39],ref.felt[,32],ref.felt[,30],ref.felt[,40],ref.felt[,36],ref.felt[,37],ref.felt[,38],ref.felt[,41],ref.felt[,33],ref.felt[,31],ref.felt[,35],ref.felt[,29],ref.felt[,11],ref.felt[,7],ref.felt[,18],ref.felt[,10],ref.felt[,16],ref.felt[,19],ref.felt[,21],ref.felt[,15],ref.felt[,23],ref.felt[,22],ref.felt[,14],ref.felt[,3],ref.felt[,1],ref.felt[,9],ref.felt[,12],ref.felt[,20],Floan_bru[,3],ref.felt[,4],ref.felt[,17],ref.felt[,8],ref.felt[,2],ref.felt[,13],ref.felt[,24],ref.felt[,28],ref.felt[,25],ref.felt[,27],ref.felt[,26],stringsAsFactors = FALSE,row.names=TRUE,names=TRUE)


fout="Q_ref_felt.txt"
write.table(ref.felt.FID, file =fout, append = FALSE, quote = FALSE, sep = "\t ", row.names = TRUE,col.names = TRUE, )

#Trengs til rdist scriptet
#Q=matrix(scan("C:/Users/Erlend/Documents/NTNU/Prosjektoppgave/kartdata/Vannfringsdata/Q_ref_felt.txt"),skip=1,35430,44, byrow=T)

