# Erlend 2. april 2014
# Lage koder til forskjellige ting til oppgaveteksten

# Boxplot oversikt over areal for NTE- og NVE-felt
areal_NTE=c(45.1,17.3,60.6,119.7,60.6,13.9,434.1,64.1,15,263,1774.1,71.9,53.9)
atrtab=read.table("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/Alle felt.txt", header=TRUE)
areal_NVE=atrtab[14:48,3]/1000000
areal=cbind(areal_NTE, areal_NVE)
par(mfrow=c(1,1))
boxplot(areal_NTE, log="y", ylab="Areal [km]",xlab="NTE-felt                     NVE-felt", main="Arealfordeling", at=1, xlim=c(0,3))
boxplot(areal_NVE, log="y", at=2, add=TRUE)

graphics.off()
rm(list=ls())

#######################
# Sjekke dataseriene til NVE-felt
##############
Q_inn=matrix(scan("C:/Users/Erlend/Documents/NTNU/Prosjektoppgave/kartdata/Vannfringsdata/Q_ref_felt.txt",skip=1),35430,45, byrow=T)
#Q <- read.table("C:/Users/Erlend/Documents/NTNU/Prosjektoppgave/kartdata/Vannfringsdata/Q_ref_felt.txt", header=T)#, skip = 3)
Q=Q_inn[,2:45]
Q[Q==-9999] <- NA
par(mfrow=c(1,1))
for( i in 12:12){
  ts=Q[1:35430,i]
  ts=as.ts(ts)
  plot(ts, ylab=paste("catchment",i))
}

###############################
# Vise fordelingen av Q-data
#Bruker Qdata over
Moen=Q[21337:35430,25]
par(mfrow=c(1,1))
hist(Q[,25], probability=TRUE, breaks=20, main="Fordeling av vannfringsdata for 139.20 Moen", xlab="Q [m3/s]", ylab="Tetthet")
mean=mean(Moen)
abline(v=mean, col="grey", lwd=2)
boxplot(Q[,25], ylab="Q[m3/s]", log="y", add=TRUE)
mean=mean(Moen)
abline(h=mean, col="grey", lwd=2)

#FDC
rank       <- rank(Moen, ties.method="max")
rank       <- max(rank)-rank
exceedtime <- 100 * (rank / (length(Moen)+1))
Flow_exceeded=sort(exceedtime, decreasing=T)
Flow=sort(Moen)
true=cbind(Flow_exceeded,Flow)
plot(true, col="black", type="l", main="Varighetskurve for Moen", ylab="Q [m3/s]", xlab="% i tid oversteget", log="y")
abline(h=mean, col="grey", lwd=2)

######################################
# Boxplot med korrelasjonsverdiene til alle ko-variablene
covar=read.table("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/Covariables/Cov_corr/cov_corr.txt", header=TRUE)
par(mfrow=c(1,5))
boxplot(covar[,2], main="Cr", ylim=c(0,1))
boxplot(covar[,3], main="Rr", ylim=c(0,1))
boxplot(covar[,4], main="Dd", ylim=c(0,1))
boxplot(covar[,5], main="TWI", ylim=c(0,1))
boxplot(covar[,6], main="WI", ylim=c(0,1))

#Boxplot med kovariabel-verdiene
covar=read.table("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/Covariables/covar.txt", header=TRUE, sep=",")
par(mfrow=c(1,5))
boxplot(covar[,4], main="Cr [m2/m]")
boxplot(covar[,5]*1000, main="Rr [m/km]")
boxplot(covar[,6], main="Dd")
boxplot(covar[,7], main="TWI")
boxplot(covar[,8], main="WI [mm/mm]")


##########################################
# LAGE DATAPERIODE GRAF
a=rep(NA,731)
Bla=c(a,Bla)
b=rep(NA,243)
c=rep(NA,488)
Ekorn=c(b,Ekorn,c)
d=rep(NA,365)
e=rep(NA,366)
Helli=c(d,Helli,e)
f=rep(NA,609)
g=rep(NA,90)
Kjerr=c(f,Kjerr,g)
h=rep(NA,974)
Navlus=c(h,Navlus)
j=rep(NA,1634)
Sand=c(j,Sand)
k=rep(NA,1826)
Stors=c(k,Stors)
l=rep(NA,365)
m=rep(NA,366)
Trong=c(l,Trong,m)
n=rep(NA,1096)
Vest=c(Vest,n)
o=rep(NA,522)
p=rep(NA,916)
Vlset=c(o,Vlset,p)

Bla=(Bla/999999999999)+10
Ekorn=(Ekorn/999999999999)+9
Helli=(Helli/999999999999)+8
Kjerr=(Kjerr/999999999999)+7
Navlus=(Navlus/999999999999)+6
Sand=(Sand/999999999999)+5
Stors=(Stors/999999999999)+4
Trong=(Trong/999999999999)+3
Vest=(Vest/999999999999)+2
Vlset=(Vlset/999999999999)+1

plot(Bla, xlab="", lwd="2", main="Oversikt over perioder med data for NTE-felt",yaxt='n', ylab="", ylim=c(0,14),xlim=c(-750,2192))
lines(Ekorn, col="2", lwd="2")
lines(Helli, col="3", lwd="2")
lines(Kjerr, col="4", lwd="2")
lines(Navlus, col="5", lwd="2")
lines(Sand, col="6", lwd="2")
lines(Stors, col="7", lwd="2")
lines(Trong, col="8", lwd="2")
lines(Vest, col="9", lwd="2")
lines(Vlset, col="10", lwd="2")
legend("topleft",legend=c("Bla","Ekorndalselva","Hellifoss","Kjerra","Navlusfoss","Sandvasselva","Storselva","Trongfossen","Vestera","Vlsetelva"),col=1:10, pch=1, cex=.79)
axis(side=1, at=c(0,366,732,1097,1462,1826,2192), labels=c("1.1.2007","1.1.2008","1.1.2009","1.1.2010","1.1.2011","1.1.2012","31.12.2012"))

# Ref-felt
brstad=(Q[,32]/9999999999)+35

dillfoss=(Q[,27]/9999999999)+34
embrethlen=(Q[,18]/9999999999)+33
engstad=(Q[,26]/9999999999)+32
frsteaunvatn=(Q[,10]/9999999999)+31
grongstadvatn=(Q[,13]/9999999999)+30
grunnfoss=(Q[,24]/9999999999)+29
hggsbru=(Q[,31]/9999999999)+28
innsvatn=(Q[,29]/9999999999)+27
iskvernfoss=(Q[,14]/9999999999)+26
kapskarmo=(Q[,6]/9999999999)+25
kjeldstad=(Q[,34]/9999999999)+24
krinsvatn=(Q[,23]/9999999999)+23
landbru=(Q[,11]/9999999999)+22
lavvatn=(Q[,1]/9999999999)+21
lenglingen=(Q[,19]/9999999999)+20
mannseter=(Q[,33]/9999999999)+19
mevatnet=(Q[,4]/9999999999)+18
moen=(Q[,9]/9999999999)+17
murusj=(Q[,15]/9999999999)+16
mllehusfoss=(Q[,2]/9999999999)+15
namsvatn=(Q[,8]/9999999999)+14
nervoll=(Q[,5]/9999999999)+13
salsvatn=(Q[,12]/9999999999)+12
skjellbreivatn=(Q[,17]/9999999999)+11
stordalsvatn=(Q[,21]/9999999999999)+10
storvatn=(Q[,28]/9999999999999)+9
strompdal=(Q[,3]/9999999999999)+8
stafoss=(Q[,22]/9999999999999)+7
trangen=(Q[,16]/9999999999999)+6
tra=(Q[,35]/9999999999999)+5
valen=(Q[,30]/9999999999999)+4
veravatn=(Q[,25]/9999999999999)+3
yungen=(Q[,20]/9999999999999)+2
bjrvatn=(Q[,7]/9999999999999)+1

plot(brstad, col="1", ylim=c(0,36), type="l", lwd="2", yaxt='n',xaxt='n', ylab="",main="Oversikt over perioder med data for NVE-felt",xlim=c(-15000,35430),xlab="")
lines(dillfoss, col="2", lwd="2")
lines(embrethlen, col="3", lwd="2")
lines(engstad, col="4", lwd="2")
lines(frsteaunvatn, col="5", lwd="2")
lines(grongstadvatn, col="6", lwd="2")
lines(grunnfoss, col="7", lwd="2")
lines(hggsbru, col="8", lwd="2")
lines(innsvatn, col="9", lwd="2")
lines(iskvernfoss, col="10", lwd="2")
lines(kapskarmo, col="11", lwd="2")
lines(kjeldstad, col="12", lwd="2")
lines(krinsvatn, col="13", lwd="2")
lines(landbru, col="14", lwd="2")
lines(lavvatn, col="15", lwd="2")
lines(lenglingen, col="16", lwd="2")
lines(mannseter, col="17", lwd="2")
lines(mevatnet, col="18", lwd="2")
lines(moen, col="19", lwd="2")
lines(murusj, col="20", lwd="2")
lines(mllehusfoss, col="21", lwd="2")
lines(namsvatn, col="22", lwd="2")
lines(nervoll, col="23", lwd="2")
lines(salsvatn, col="24", lwd="2")
lines(skjellbreivatn, col="25", lwd="2")
lines(stordalsvatn, col="26", lwd="2")
lines(storvatn, col="27", lwd="2")
lines(strompdal, col="28", lwd="2")
lines(stafoss, col="29", lwd="2")
lines(trangen, col="30", lwd="2")
lines(tra, col="31", lwd="2")
lines(valen, col="32", lwd="2")
lines(veravatn, col="33", lwd="2")
lines(yungen, col="34", lwd="2")
lines(bjrvatn, col="35", lwd="2")

legend("topleft",legend=c("Brstad","Dillfoss","Embrethlen","Engstad","Frste Aunvatn","Grongstadvatn","Grunnfoss","Hggs bru","Innsvatn","Iskvernfoss","Kapskarmo","Kjeldstad i Garbergelva","Krinsvatn","Landbru limn.","Lavvatn","Lenglingen","Mannseter","Mevatnet","Moen","Murusj","Mllehusfoss","Namsvatn","Nervoll","Salsvatn","Skjellbreivatn","Stordalsvatn","Storvatn-Svartelva","Strompdal","Stafoss","Trangen","Tra","Valen","Veravatn","yungen","bjrvatn"),col=1:35, pch=1, cex=.9, y.intersp=0.75,bty='n')
axis(side=1, at=c(0,7086,14172,21258,28344,35430), labels=c("1916","1935","1954","1974","1993","2012"))


################################
# Dist_corr plott for NTE-feltene
NTE_corr=read.table("C:/Users/Erlend/Documents/NTNU/Masteroppgave/test/dist_corr_plot.txt")
plot(NTE_corr[,14]~NTE_corr[,1], main = "Distanse og korrelasjon for Vlsetelva", cex=2,cex.axis=2,cex.main = 2,pch=21,cex.lab=2,xlab = "Distanse [km]",ylab ="Kendalls tau",ylim=c(0,1))
lm_model <- lm(NTE_corr[,14]~NTE_corr[,1])
abline(fit <- (lm_model), col="blue", lwd=2)

plot(NTE_corr[,15]~NTE_corr[,2], main = "Distanse og korrelasjon for Vestera", cex=2,cex.axis=2,cex.main = 2,pch=21,cex.lab=2,xlab = "Distanse [km]",ylab ="Kendalls tau",ylim=c(0,1))
lm_model <- lm(NTE_corr[,15]~NTE_corr[,2])
abline(fit <- (lm_model), col="blue", lwd=2)

plot(NTE_corr[,17]~NTE_corr[,4], main = "Distanse og korrelasjon for Trongfossen", cex=2,cex.axis=2,cex.main = 2,pch=21,cex.lab=2,xlab = "Distanse [km]",ylab ="Kendalls tau",ylim=c(0,1))
lm_model <- lm(NTE_corr[,17]~NTE_corr[,4])
abline(fit <- (lm_model), col="blue", lwd=2)

plot(NTE_corr[,18]~NTE_corr[,5], main = "Distanse og korrelasjon for Storselva", cex=2,cex.axis=2,cex.main = 2,pch=21,cex.lab=2,xlab = "Distanse [km]",ylab ="Kendalls tau",ylim=c(0,1))
lm_model <- lm(NTE_corr[,18]~NTE_corr[,5])
abline(fit <- (lm_model), col="blue", lwd=2)

plot(NTE_corr[,19]~NTE_corr[,6], main = "Distanse og korrelasjon for Sandvasselva", cex=2,cex.axis=2,cex.main = 2,pch=21,cex.lab=2,xlab = "Distanse [km]",ylab ="Kendalls tau",ylim=c(0,1))
lm_model <- lm(NTE_corr[,19]~NTE_corr[,6])
abline(fit <- (lm_model), col="blue", lwd=2)

plot(NTE_corr[,21]~NTE_corr[,8], main = "Distanse og korrelasjon for Navlusfoss", cex=2,cex.axis=2,cex.main = 2,pch=21,cex.lab=2,xlab = "Distanse [km]",ylab ="Kendalls tau",ylim=c(0,1))
lm_model <- lm(NTE_corr[,21]~NTE_corr[,8])
abline(fit <- (lm_model), col="blue", lwd=2)

plot(NTE_corr[,22]~NTE_corr[,9], main = "Distanse og korrelasjon for Kjerra", cex=2,cex.axis=2,cex.main = 2,pch=21,cex.lab=2,xlab = "Distanse [km]",ylab ="Kendalls tau",ylim=c(0,1))
lm_model <- lm(NTE_corr[,22]~NTE_corr[,9])
abline(fit <- (lm_model), col="blue", lwd=2)

plot(NTE_corr[,23]~NTE_corr[,10], main = "Distanse og korrelasjon for Hellifoss", cex=2,cex.axis=2,cex.main = 2,pch=21,cex.lab=2,xlab = "Distanse [km]",ylab ="Kendalls tau",ylim=c(0,1))
lm_model <- lm(NTE_corr[,23]~NTE_corr[,10])
abline(fit <- (lm_model), col="blue", lwd=2)

plot(NTE_corr[,25]~NTE_corr[,12], main = "Distanse og korrelasjon for Ekorndalselva", cex=2,cex.axis=2,cex.main = 2,pch=21,cex.lab=2,xlab = "Distanse [km]",ylab ="Kendalls tau",ylim=c(0,1))
lm_model <- lm(NTE_corr[,25]~NTE_corr[,12])
abline(fit <- (lm_model), col="blue", lwd=2)

plot(NTE_corr[,26]~NTE_corr[,13], main = "Distanse og korrelasjon for Bla", cex=2,cex.axis=2,cex.main = 2,pch=21,cex.lab=2,xlab = "Distanse [km]",ylab ="Kendalls tau",ylim=c(0,1))
lm_model <- lm(NTE_corr[,26]~NTE_corr[,13])
abline(fit <- (lm_model), col="blue", lwd=2)

# Areal og korrelasjonsplott
areal=read.table("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/Feltparametre.txt",header=TRUE)
areal=areal(14:48,3:4)
plot(NTE_corr[,26]~areal[,2], main = "Areal og korrelasjon for Bla 45,1km2", cex=2,cex.axis=2,cex.main = 2,pch=21,cex.lab=2,xlab = "Feltareal [km2]",ylab ="Kendalls tau",ylim=c(0,1))