# Erlend april 2014
## Tradisjonell skalering for sammenligning
rm(list=ls())
setwd("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Resultater/Skalering/")

Q_inn=matrix(scan("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/Q_ref_felt.txt",skip=1),35430,36, byrow=T)
Q=Q_inn[,2:36]
Q[Q==-9999] <- NA

#Skalering fra 1.1.2008 til 31.12.2012. 1.1.2000 = 30682
# Bla skaleres med Stafoss (22)
# Bla fr ogs Stafoss som skaleringsstasjon etter OK og OcK

Q_Bola=((45.1*33.8)/(477*36.5))*Q[33604:35430,22]



#Fisklysa VM skaleres med Murusj
# Gjelder ogs etter OK og OcK
Q_Fisk=((60.6*39.4)/(345.9*24.4))*Q[33604:35430,15]


#Flttadal skaleres med Moen

Q_Fltt=((119.7*84.7)/(63.9*61.6))*Q[33604:35430,9]

# Gjelder ogs etter OK, men fr Mannseter som skaleringsstasjon etter OcK

Q_Fltt_OcK=((119.7*84.7)/(96.8*38.8))*Q[33604:35430,33]


#Hellifoss skaleres med Frste Aunvatn, data fra 1.1.2008=33604 til 31.12.2011=35064
#Gjelder ogs etter OK og OcK
Q_Helli=((60.6*84)/(87.6*110.7))*Q[33604:35064,10] # serien starter 24450-

#Vlsetelva skaleres med Krinsvatn (23)

Q_Vlset=((53.9*53.3)/(206.3*63.8))*Q[33604:35430,23]
#Vlsetelva fr Stordalsvatn som skaleringsstasjon etter OK og OcK. Stordalsvatn har data frem til 34000
#Nest best er (43) Krinsvatn
Q_Vlset_OcK=((53.9*53.3)/(226.0*49.2))*Q[33604:35430,21]
Q_Vlset_Ock2=((53.9*53.3)/(206.3*63.8))*Q[33604:35430,23]

#Sandvasselva skaleres med yungen, data fra 23.6.2011=34873 til 31.12.2012=35430

Q_Sand=((15*58.2)/(239.7*50.6))*Q[1:35430,20]
#Sandvasselva fr Stordalsvatn som skaleringsstasjon etter OK og OcK. Stordalsvatn har data frem til 34000
#Nest best er (23) Krinsvatn
Q_Sand_OcK=((15*58.2)/(226*49.2))*Q[29100:34200,21]
Q_Sand_OcK2=((15*58.2)/(206.3*63.8))*Q[34873:35430,23]

#Navlusfoss skaleres med Embrethlen

Q_Navlus=((434.1*28)/(494.3*40.6))*Q[33604:35430,18]
#Gjelder ogs etter OK og OcK

#Storselva skaleres med Embrethlen
#Gjelder ogs etter OK og OcK
Q_Stors=((263*28.8)/(494.3*40.6))*Q[35065:35430,18]

#Vestera skaleres med yungen. Data fra 1.1.2007=33239 til 31.12.2009=34334
#Gjelder ogs etter OK, men Veravatn etter OcK
Q_Vest=((71.9*33.6)/(239.7*50.6))*Q[33239:34334,20]

Q_Vest_OcK=((71.9*33.6)/(175.7*36.2))*Q[33239:34334,25]

#Ekorndalselva skaleres med Grongstadvatn. Data fra 1.9.2007=33482 til 31.8.2011=34942
# Skaleres med Salsvatn etter OK
# Skaleres med Innsvatn etter OcK, men den er nedlagt. Ellers 25 Veravatn.
Q_Ekorn=((17.3*66.7)/(471.6*68.1))*Q[33482:34942,13]
Q_Ekorn_OK=((17.3*66.7)/(432.1*59.3))*Q[33482:34942,12]
Q_Ekorn_OcK=((17.3*66.7)/(95.6*35.4))*Q[21000:27500,29] #Innsvatn
Q_Ekorn_OcK_2=((17.3*66.7)/(175.7*36.2))*Q[33482:34942,25] #Veravatn


#Trongfossen skaleres med Moen

Q_Trong=((1774.1*47.9)/((63.9*61.6))*Q[33604:35430,9]
#Moen etter OK, Kapskarmo etter OcK
Q_Trong_OK=((1774.1*47.9)/(474,3*62))*Q[33604:35430,6]

#Kjerra skaleres med Moen. Har data fra 1.9.2008=33848 til 2.10.2012=35340

Q_Kjerr=((13.9*42.2)/(63.9*61.6))*Q[33848:35340,9]
#Gjelder ogs etter OK, men Veravatn etter OcK
Q_Kjerr_OcK=((13.9*42.2)/(175.7*36.2))*Q[33848:35340,25]

#Saksvatn skaleres ogs med Moen
#Ogs etter OK, men Landbru_limn etter OcK
Q_Saks=((64.1*37.8)/(63.9*61.6))*Q[33604:35430,9]
Q_Saks_OcK=((64.1*37.8)/(62*44.0))*Q[33604:35430,11]


fout=cbind(Q_Bla, Q_Ekorn, Q_Fisk, Q_Fltt, Q_Helli, Q_Kjerr, Q_Navlus, Q_Saks, Q_Sand, Q_Stors, Q_Trong, Q_Vest, Q_Vlset)

write.table(fout,"Skalering.txt", quote = F, col.names = c("Bla","Ekorndalselva", "Fisklysa VM","Flttadal","Hellifoss","Kjerra","Navlusfoss","Saksvatn","Sandvasselva","Storselva","Trongfossen","Vestera","Vlsetelva"),row.names =F, sep=",")


##################################################################################
# Eksempel for evaluering
# Ekorndalselva
OcK_res=read.table("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/OcK/ NTE_PRED.txt", skip=1)
OcK=OcK_res[,3:37]
apply(OcK,1,max)
apply(OcK,1,which.max)

Ekorn=read.table("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/Data fra NTE/Q/Q-Ekorndal 2007-2011.txt",skip=1)
Ekorn=Ekorn[,3]
Ekorn=as.ts(Ekorn)
Q_Ekorn=((17.3*66.7)/(471.6*68.1))*Q[33482:34942,13]
#Q_Vest=Q_Vest[245:1737]
Q_Ekorn=as.ts(Q_Ekorn)
#Q_Ekorn_OK=((17.3*66.7)/(432.1*59.3))*Q[33482:34942,12]
#Q_Ekorn_OK=as.ts(Q_Ekorn_OK)
Q_Ekorn_OcK=((17.3*66.7)/(175.7*36.2))*Q[33482:34942,25]
#Q_Vest_OcK=Q_Vest_OcK[245:1737]
Q_Ekorn_OcK=as.ts(Q_Ekorn_OcK)
#Fr egentlig Innsvatn som skaleringsfelt etter OcK
#Q_Ekorn_OcK=((17.3*66.7)/(95.6*35.4))*Q[21000:27500,29]
#Q_Ekorn_OcK=as.ts(Q_Ekorn_OcK)

par(mfrow=c(1,1))
ts.plot(Ekorn, Q_Ekorn, Q_Ekorn_OcK, gpars=list(col=1:3),main="Ekorndalselva", ylab="Q [m3/s]", xlab="Dgn fra 1.9.2007")
legend("topleft", legend = c("Ekorndalselva","Skalert med Grongstadvatn", "OcK: Skalert med Veravatn"), col=1:3, pch=1, cex=1)
library(topmodel)
NSeff(Ekorn,Q_Ekorn)
#NSeff(Ekorn,Q_Ekorn_OK)
NSeff(Ekorn,Q_Ekorn_OcK)

write.table(cbind(Ekorn,Q_Ekorn,Q_Ekorn_OcK), file = paste("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Resultater/Skalering/","Ekorndalselva.txt",sep=""),quote =FALSE, sep = ",", col.names = c("Ekorndalselva","Skalert med Grongstadvatn", "OcK: Skalert med Veravatn"))


#2008 er medianret, 123:488
Ekorn_r=as.ts(Ekorn[123:488])
Q_Ekorn_r=as.ts(Q_Ekorn[123:488])
Q_Ekorn_OcK_r=as.ts(Q_Ekorn_OcK[123:488])

#fdc_Ekorn=fdc(Ekorn)
#fdc_trad=fdc(Q_Ekorn)
#fdc_OcK=fdc(Q_Ekorn_OcK)
##############################################################################
rank       <- rank(Ekorn, ties.method="max")
rank       <- max(rank)-rank
exceedtime <- 100 * (rank / (length(Ekorn)+1))
Flow_exceeded=sort(exceedtime, decreasing=T)
Flow=sort(Ekorn)
true=cbind(Flow_exceeded,Flow)

rank1       <- rank(Q_Ekorn, ties.method="max")
rank1       <- max(rank1)-rank1
exceedtime1 <- 100 * (rank1 / (length(Q_Ekorn)+1))
Flow_exceeded1=sort(exceedtime1, decreasing=T)
Flow1=sort(Q_Ekorn)
Skal=cbind(Flow_exceeded1,Flow1)


rank2       <- rank(Q_Ekorn_OcK, ties.method="max")
rank2       <- max(rank2)-rank2
exceedtime2 <- 100 * (rank2 / (length(Q_Ekorn_OcK)+1))
Flow_exceeded2=sort(exceedtime2, decreasing=T)
Flow2=sort(Q_Ekorn_OcK)
OcK=cbind(Flow_exceeded2,Flow2)

#par(mfrow=c(1,1))

plot(true, col="black", type="l",lwd=4, main="Varighetskurve for Ekorndalselva", ylab="Q [m3/s]", xlab="% i tid oversteget", log="y")
lines(Skal, col="red", lwd=2)
lines(OcK, col="blue", lwd=2)
legend("topright", legend = c("Sann Q Ekorndalselva","Skalert med Grongstadvatn","OcK: Skalert med Veravatn"), col=c("black","red","blue"), pch=1, cex=1)

NSeff(true,Skal)
NSeff(true,OcK)
## Verdier  sammenligne. Hvor er middelvannfringen p varighetskurven?
##              Slukeevne=2*Qmiddel. Hvor stor er den?
##              Lavvannsverdier. F.eks. 5-persentil.
# Fem-persentil sammenligning
fempers=true[which(abs(true[,1]-95)==min(abs(true[,1]-95)))]
true[true[,1]==fempers]
fempers=Skal[which(abs(Skal[,1]-95)==min(abs(Skal[,1]-95)))]
Skal[Skal[,1]==fempers]
fempers=OcK[which(abs(OcK[,1]-95)==min(abs(OcK[,1]-95)))]
OcK[OcK[,1]==fempers]

# Qmiddel sammenligning
# Sann Qmiddel
Qm=sum(Ekorn)/length(Ekorn)
Qm_2=sum(Q_Ekorn)/length(Q_Ekorn)
Qm_4=sum(Q_Ekorn_OcK)/length(Q_Ekorn_OcK)

# Slukeevne er dobbel Qmiddel. Finne hvilken persentil denne svarer til.
abdu=true[which(abs(true[,2]-(2*Qm))==min(abs(true[,2]-(2*Qm))))]
Q_sluk_true=true[true[,1]==abdu]

######################################SLUTT############################################
#Kjerra
rm(list=ls())
Kjerr=read.table("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/Data fra NTE/Q/kjeraaQ08-12.txt",skip=1)
Kjerr=Kjerr[,3]
Kjerr=as.ts(Kjerr)

Q_Kjerr=((13.9*42.2)/(63.9*61.6))*Q[33848:35340,9]
#
Q_Kjerr=as.ts(Q_Kjerr)

Q_Kjerr_OcK=((13.9*42.2)/(175.7*36.2))*Q[33848:35340,25]
#
Q_Kjerr_OcK=as.ts(Q_Kjerr_OcK)


par(mfrow=c(1,1))
ts.plot(Kjerr, Q_Kjerr, Q_Kjerr_OcK, gpars=list(col=1:3),main="Kjerra", ylab="Q [m3/s]", xlab="Dgn fra 1.9.2008")
legend("topleft", legend = c("Kjerra","Skalert med Moen", "OcK: Skalert med Veravatn"), col=1:3, pch=1, cex=1)
library(topmodel)
NSeff(Kjerr,Q_Kjerr)
NSeff(Kjerr,Q_Kjerr_OcK)


write.table(cbind(Kjerr,Q_Kjerr,Q_Kjerr_OcK), file = paste("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Resultater/Skalering/","Kjerra.txt",sep=""),quote =FALSE, sep = ",", col.names = c("Kjerra","Skalert med Moen","OcK: Skalert med Veravatn"))


#Medianr er 2009, 123:487
Kjerr_r=as.ts(Kjerr[123:487])
Q_Kjerr_r=as.ts(Q_Kjerr[123:487])
Q_Kjerr_OcK_r=as.ts(Q_Kjerr_OcK[123:487])

#fdc_Ekorn=fdc(Ekorn)
#fdc_trad=fdc(Q_Ekorn)
#fdc_OcK=fdc(Q_Ekorn_OcK)
##############################################################################
rank       <- rank(Kjerr, ties.method="max")
rank       <- max(rank)-rank
exceedtime <- 100 * (rank / (length(Kjerr)+1))
Flow_exceeded=sort(exceedtime, decreasing=T)
Flow=sort(Kjerr)
true=cbind(Flow_exceeded,Flow)

rank1       <- rank(Q_Kjerr, ties.method="max")
rank1       <- max(rank1)-rank1
exceedtime1 <- 100 * (rank1 / (length(Q_Kjerr)+1))
Flow_exceeded1=sort(exceedtime1, decreasing=T)
Flow1=sort(Q_Kjerr)
Skal=cbind(Flow_exceeded1,Flow1)

rank2       <- rank(Q_Kjerr_OcK, ties.method="max")
rank2       <- max(rank2)-rank2
exceedtime2 <- 100 * (rank2 / (length(Q_Kjerr_OcK)+1))
Flow_exceeded2=sort(exceedtime2, decreasing=T)
Flow2=sort(Q_Kjerr_OcK)
OcK=cbind(Flow_exceeded2,Flow2)

#par(mfrow=c(1,1))

plot(true, col="black", type="l",lwd=4, main="Varighetskurve for Kjerra", ylab="Q [m3/s]", xlab="% i tid oversteget", log="y")
lines(Skal, col="red", lwd=2)
#lines(OK, col="green", lwd=2)
lines(OcK, col="blue", lwd=2)
legend("topright", legend = c("Sann Q Kjerra","Skalert med Moen","OcK: Skalert med Veravatn"), col=c("black","red","blue"), pch=1, cex=1)

NSeff(true,Skal)
NSeff(true,OcK)
## Verdier  sammenligne. Hvor er middelvannfringen p varighetskurven?
##              Slukeevne=2*Qmiddel. Hvor stor er den?
##              Lavvannsverdier. F.eks. 5-persentil.
# Fem-persentil sammenligning
fempers=true[which(abs(true[,1]-95)==min(abs(true[,1]-95)))]
true[true[,1]==fempers]
fempers=Skal[which(abs(Skal[,1]-95)==min(abs(Skal[,1]-95)))]
Skal[Skal[,1]==fempers]
fempers=OcK[which(abs(OcK[,1]-95)==min(abs(OcK[,1]-95)))]
OcK[OcK[,1]==fempers]

# Qmiddel sammenligning
# Sann Qmiddel
Qm=sum(Kjerr)/length(Kjerr)
Qm_2=sum(Q_Kjerr)/length(Q_Kjerr)
Qm_4=sum(Q_Kjerr_OcK)/length(Q_Kjerr_OcK)

# Slukeevne er dobbel Qmiddel. Finne hvilken persentil denne svarer til.
abdu=true[which(abs(true[,2]-(2*Qm))==min(abs(true[,2]-(2*Qm))))]
Q_sluk_true=true[true[,1]==abdu]


###################################################################################
#Vestera
rm(list=ls())
Vest=read.table("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/Data fra NTE/Q/Qvesteraa, NTE-hydr pr okt10.txt",skip=1)
Vest=Vest[,3]
Vest=as.ts(Vest)

#Vestera skaleres med yungen. Data fra 1.1.2007=33239 til 31.12.2009=34334
#Gjelder ogs etter OK, men Veravatn etter OcK
Q_Vest=((71.9*33.6)/(239.7*50.6))*Q[33239:34334,20]
Q_Vest=as.ts(Q_Vest)
Q_Vest_OcK=((71.9*33.6)/(175.7*36.2))*Q[33239:34334,25]
Q_Vest_OcK=as.ts(Q_Vest_OcK)

par(mfrow=c(1,1))
ts.plot(Vest, Q_Vest, Q_Vest_OcK, gpars=list(col=1:3),main="Vestera", ylab="Q [m3/s]", xlab="Dgn fra 1.1.2007")
legend("topleft", legend = c("Vestera","Skalert med yungen", "OcK: Skalert med Veravatn"), col=1:3, pch=1, cex=1)
library(topmodel)
NSeff(Vest,Q_Vest)
NSeff(Vest,Q_Vest_OcK)
write.table(cbind(Vest,Q_Vest,Q_Vest_OcK), file = paste("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Resultater/Skalering/","Vest.txt",sep=""),quote =FALSE, sep = ",", col.names = c("Vestera","Skalert med yungen", "OcK: Skalert med Veravatn"))
                                                                                                                                                                                                                              



# Siste ret, 2009, er median
Vest_med=as.ts(Vest[732:1096])
Q_Vest_med=as.ts(Q_Vest[732:1096])
Q_Vest_OcK_med=as.ts(Q_Vest_OcK[732:1096])
#fdc_Ekorn=fdc(Ekorn)
#fdc_trad=fdc(Q_Ekorn)
#fdc_OcK=fdc(Q_Ekorn_OcK)
##############################################################################
rank       <- rank(Vest, ties.method="max")
rank       <- max(rank)-rank
exceedtime <- 100 * (rank / (length(Vest)+1))
Flow_exceeded=sort(exceedtime, decreasing=T)
Flow=sort(Vest)
true=cbind(Flow_exceeded,Flow)

rank1       <- rank(Q_Vest, ties.method="max")
rank1       <- max(rank1)-rank1
exceedtime1 <- 100 * (rank1 / (length(Q_Vest)+1))
Flow_exceeded1=sort(exceedtime1, decreasing=T)
Flow1=sort(Q_Vest)
Skal=cbind(Flow_exceeded1,Flow1)

rank2       <- rank(Q_Vest_OcK, ties.method="max")
rank2       <- max(rank2)-rank2
exceedtime2 <- 100 * (rank2 / (length(Q_Vest_OcK)+1))
Flow_exceeded2=sort(exceedtime2, decreasing=T)
Flow2=sort(Q_Vest_OcK)
OcK=cbind(Flow_exceeded2,Flow2)

#par(mfrow=c(1,1))

plot(true, col="black", type="l",lwd=4, main="Varighetskurve for Vestera", ylab="Q [m3/s]", xlab="% i tid oversteget", log="y")
lines(Skal, col="red", lwd=2)
#lines(OK, col="green", lwd=2)
lines(OcK, col="blue", lwd=2)
legend("topright", legend = c("Sann Q Vestera","Skalert med yungen","OcK: Skalert med Veravatn"), col=c("black","red","blue"), pch=1, cex=1)

NSeff(true,Skal)
NSeff(true,OcK)
## Verdier  sammenligne. Hvor er middelvannfringen p varighetskurven?
##              Slukeevne=2*Qmiddel. Hvor stor er den?
##              Lavvannsverdier. F.eks. 5-persentil.
# Fem-persentil sammenligning
fempers=true[which(abs(true[,1]-95)==min(abs(true[,1]-95)))]
true[true[,1]==fempers]
fempers=Skal[which(abs(Skal[,1]-95)==min(abs(Skal[,1]-95)))]
Skal[Skal[,1]==fempers]
fempers=OK[which(abs(OK[,1]-95)==min(abs(OK[,1]-95)))]
OK[OK[,1]==fempers]
fempers=OcK[which(abs(OcK[,1]-95)==min(abs(OcK[,1]-95)))]
OcK[OcK[,1]==fempers]

# Qmiddel sammenligning
# Sann Qmiddel
Qm=sum(Vest)/length(Vest)
Qm_2=sum(Q_Vest)/length(Q_Vest)
Qm_4=sum(Q_Vest_OcK)/length(Q_Vest_OcK)

# Slukeevne er dobbel Qmiddel. Finne hvilken persentil denne svarer til.
abdu=true[which(abs(true[,2]-(2*Qm_2))==min(abs(true[,2]-(2*Qm_2))))]
Q_sluk_true=true[true[,1]==abdu]

######################################################################################
# Trongfossen
# Namsvatn blir overfrt ut (696 km2). Regulert og krav om minstevannfring 12m3/s om sommer, 2m3/s om vinter.
rm(list=ls())
Trong=read.table("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/Data fra NTE/Q/trongQ0811.txt",skip=1)
Trong=Trong[,3]
Trong=as.ts(Trong)



Q_Trong=((1774.1*47.9)/((63.9*61.6))*Q[33604:35064,9])
Q_Trong=as.ts(Q_Trong)
#Moen etter OK, Kapskarmo etter OcK

Q_Trong_OcK=((1774.1*47.9)/(474.3*62))*Q[22000:23460,6]
Q_Trong_OcK=as.ts(Q_Trong_OcK)

par(mfrow=c(1,1))
ts.plot(Trong, Q_Trong, Q_Trong_OcK, gpars=list(col=1:3),main="Trongfossen", ylab="Q [m3/s]", xlab="Dgn fra 1.1.2007")
legend("topleft", legend = c("Trongfossen","Skalert med Moen"), col=1:2, pch=1, cex=1)
library(topmodel)
NSeff(Trong,Q_Trong)
NSeff(Trong,Q_Trong_OcK)



#fdc_Ekorn=fdc(Ekorn)
#fdc_trad=fdc(Q_Ekorn)
#fdc_OcK=fdc(Q_Ekorn_OcK)
##############################################################################
rank       <- rank(Trong, ties.method="max")
rank       <- max(rank)-rank
exceedtime <- 100 * (rank / (length(Trong)+1))
Flow_exceeded=sort(exceedtime, decreasing=T)
Flow=sort(Trong)
true=cbind(Flow_exceeded,Flow)

rank1       <- rank(Q_Trong, ties.method="max")
rank1       <- max(rank1)-rank1
exceedtime1 <- 100 * (rank1 / (length(Q_Trong)+1))
Flow_exceeded1=sort(exceedtime1, decreasing=T)
Flow1=sort(Q_Trong)
Skal=cbind(Flow_exceeded1,Flow1)

rank2       <- rank(Q_Trong_OcK, ties.method="max")
rank2       <- max(rank2)-rank2
exceedtime2 <- 100 * (rank2 / (length(Q_Trong_OcK)+1))
Flow_exceeded2=sort(exceedtime2, decreasing=T)
Flow2=sort(Q_Trong_OcK)
OcK=cbind(Flow_exceeded2,Flow2)

#par(mfrow=c(1,1))

plot(true, col="black", type="l",lwd=4, main="Varighetskurve for Trongfossen", ylab="Q [m3/s]", xlab="% i tid oversteget", log="y")
lines(Skal, col="red", lwd=2)
#lines(OK, col="green", lwd=2)
lines(OcK, col="blue", lwd=2)
legend("topright", legend = c("Sann Q Trongfossen","Skalert med Moen","OcK: Skalert med Kapskarmo"), col=c("black","red","blue"), pch=1, cex=1)

NSeff(true,Skal)
NSeff(true,OcK)
## Verdier  sammenligne. Hvor er middelvannfringen p varighetskurven?
##              Slukeevne=2*Qmiddel. Hvor stor er den?
##              Lavvannsverdier. F.eks. 5-persentil.
# Fem-persentil sammenligning
fempers=true[which(abs(true[,1]-95)==min(abs(true[,1]-95)))]
true[true[,1]==fempers]
fempers=Skal[which(abs(Skal[,1]-95)==min(abs(Skal[,1]-95)))]
Skal[Skal[,1]==fempers]
fempers=OK[which(abs(OK[,1]-95)==min(abs(OK[,1]-95)))]
OK[OK[,1]==fempers]
fempers=OcK[which(abs(OcK[,1]-95)==min(abs(OcK[,1]-95)))]
OcK[OcK[,1]==fempers]

# Qmiddel sammenligning
# Sann Qmiddel
Qm=sum(Trong)/length(Trong)
Qm_2=sum(Q_Trong)/length(Q_Trong)
Qm_4=sum(Q_Trong_OcK)/length(Q_Trong_OcK)

# Slukeevne er dobbel Qmiddel. Finne hvilken persentil denne svarer til.
abdu=true[which(abs(true[,2]-(2*Qm_2))==min(abs(true[,2]-(2*Qm_2))))]
Q_sluk_true=true[true[,1]==abdu]

####################################
#Vlsetelva
#Vlsetelva skaleres med Krinsvatn (23)

Q_Vlset=((53.9*53.3)/(206.3*63.8))*Q[33761:34514,23]
#Vlsetelva fr Stordalsvatn som skaleringsstasjon etter OK og OcK. Stordalsvatn har data frem til 34000
#Nest best er (23) Krinsvatn
Q_Vlset_OcK=((53.9*53.3)/(226.0*49.2))*Q[33761:34514,21]
Q_Vlset_OcK2=((53.9*53.3)/(206.3*63.8))*Q[33761:34514,23]

Vlset=read.table("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/Data fra NTE/Q/Vollselva vf-data Nordtrnderlag_mlestasjon 2008-10.txt",skip=1)
Vlset=Vlset[,3]
Vlset=as.ts(Vlset)

#
Q_Vlset=as.ts(Q_Vlset)

#
Q_Vlset_OcK=as.ts(Q_Vlset_OcK)

Q_Vlset_OcK2=as.ts(Q_Vlset_OcK2)


par(mfrow=c(1,1))
ts.plot(Vlset, Q_Vlset, Q_Vlset_OcK, gpars=list(col=1:3),main="Vlsetelva", ylab="Q [m3/s]", xlab="Dgn fra 6.6.2008")
legend("topleft", legend = c("Vlsetelva","Skalert med Krinsvatn", "OcK: Skalert med Stordalsvatn"), col=1:3, pch=1, cex=1)
library(topmodel)
NSeff(Vlset[1:574],Q_Vlset[1:574])
NSeff(Vlset[1:574],Q_Vlset_OcK[1:574])

write.table(cbind(Vlset,Q_Vlset,Q_Vlset_OcK), file = paste("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Resultater/Skalering/","Vlset.txt",sep=""),quote =FALSE, sep = ",", col.names = c("Vestera","Skalert med yungen", "OcK: Skalert med Veravatn"))

Vlset_r=as.ts(Vlset[209:573])
Q_Vlset_r=as.ts(Q_Vlset[209:573])
Q_Vlset_OcK_r=as.ts(Q_Vlset_OcK[209:573])
#fdc_Ekorn=fdc(Ekorn)
#fdc_trad=fdc(Q_Ekorn)
#fdc_OcK=fdc(Q_Ekorn_OcK)
##############################################################################
rank       <- rank(Vlset[1:574], ties.method="max")
rank       <- max(rank)-rank
exceedtime <- 100 * (rank / (length(Vlset[1:574])+1))
Flow_exceeded=sort(exceedtime, decreasing=T)
Flow=sort(Vlset[1:574])
true=cbind(Flow_exceeded,Flow)

rank1       <- rank(Q_Vlset[1:574], ties.method="max")
rank1       <- max(rank1)-rank1
exceedtime1 <- 100 * (rank1 / (length(Q_Vlset[1:574])+1))
Flow_exceeded1=sort(exceedtime1, decreasing=T)
Flow1=sort(Q_Vlset[1:574])
Skal=cbind(Flow_exceeded1,Flow1)

rank2       <- rank(Q_Vlset_OcK[1:574], ties.method="max")
rank2       <- max(rank2)-rank2
exceedtime2 <- 100 * (rank2 / (length(Q_Vlset_OcK[1:574])+1))
Flow_exceeded2=sort(exceedtime2, decreasing=T)
Flow2=sort(Q_Vlset_OcK[1:574])
OcK=cbind(Flow_exceeded2,Flow2)

#par(mfrow=c(1,1))

plot(true, col="black", type="l",lwd=4, main="Varighetskurve for Vlsetelva", ylab="Q [m3/s]", xlab="% i tid oversteget", log="y")
lines(Skal, col="red", lwd=2)
#lines(OK, col="green", lwd=2)
lines(OcK, col="blue", lwd=2)
legend("bottomleft", legend = c("Sann Q Vlsetelva","Skalert med Krinsvatn","OcK: Skalert med Stordalsvatn"), col=c("black","red","blue"), pch=1, cex=1)

NSeff(true,Skal)
NSeff(true,OcK)
## Verdier  sammenligne. Hvor er middelvannfringen p varighetskurven?
##              Slukeevne=2*Qmiddel. Hvor stor er den?
##              Lavvannsverdier. F.eks. 5-persentil.
# Fem-persentil sammenligning
fempers=true[which(abs(true[,1]-95)==min(abs(true[,1]-95)))]
true[true[,1]==fempers]
fempers=Skal[which(abs(Skal[,1]-95)==min(abs(Skal[,1]-95)))]
Skal[Skal[,1]==fempers]
fempers=OK[which(abs(OK[,1]-95)==min(abs(OK[,1]-95)))]
OK[OK[,1]==fempers]
fempers=OcK[which(abs(OcK[,1]-95)==min(abs(OcK[,1]-95)))]
OcK[OcK[,1]==fempers]

# Qmiddel sammenligning
# Sann Qmiddel
Qm=sum(Vlset[1:574])/length(Vlset[1:574])
Qm_2=sum(Q_Vlset[1:574])/length(Q_Vlset[1:574])
Qm_4=sum(Q_Vlset_OcK[1:574])/length(Q_Vlset_OcK[1:574])

# Slukeevne er dobbel Qmiddel. Finne hvilken persentil denne svarer til.
abdu=true[which(abs(true[,2]-(2*Qm_3))==min(abs(true[,2]-(2*Qm_3))))]
Q_sluk_true=true[true[,1]==abdu]

acc_Vlset=cumsum(Vlset*(54/625))
acc_Q_Vlset=cumsum(Q_Vlset*(54/625))
acc_Q_Vlset_OcK=cumsum(Q_Vlset_OcK*(54/625))
plot(acc_Vlset, type="l", ylab="Akkumulert vannmengde [mill. m3]", xlab="Dager fra 6.6.2008")
lines(acc_Q_Vlset, col="red")
lines(acc_Q_Vlset_OcK, col="green")
legend("bottomright", legend = c("Sann Q Vlsetelva","Skalert med Krinsvatn","OcK: Skalert med Stordalsvatn"), col=c("black","red","blue"), pch=1, cex=1)

# For akkumulert differanse
plot(as.ts(acc_Q_Vlset_OcK-acc_Vlset))
lines(as.ts(acc_Q_Vlset-acc_Vlset))

###################STORSELVA#######################
rm(list=ls())
Stors=read.table("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/Data fra NTE/Q/StoraasQ2012.txt",skip=1)
Stors=Stors[,3]
Stors=as.ts(Stors)



Q_Stors=((263*28.8)/(494.3*40.6))*Q[35065:35430,18]
Q_Stors=as.ts(Q_Stors)


par(mfrow=c(1,1))
ts.plot(Stors, Q_Stors,gpars=list(col=1:2),main="Storselva", ylab="Q [m3/s]", xlab="Dgn fra 1.1.2012")
legend("topleft", legend = c("Storselva","Skalert med Embrethlen"), col=1:2, pch=1, cex=1)
library(topmodel)
NSeff(Stors,Q_Stors)

write.table(cbind(Stors,Q_Stors), file = paste("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Resultater/Skalering/","Stors.txt",sep=""),quote =FALSE, sep = ",", col.names = c("Storselva","Skalert med Embrethlen"))


#fdc_Ekorn=fdc(Ekorn)
#fdc_trad=fdc(Q_Ekorn)
#fdc_OcK=fdc(Q_Ekorn_OcK)
##############################################################################
rank       <- rank(Stors, ties.method="max")
rank       <- max(rank)-rank
exceedtime <- 100 * (rank / (length(Stors)+1))
Flow_exceeded=sort(exceedtime, decreasing=T)
Flow=sort(Stors)
true=cbind(Flow_exceeded,Flow)

rank1       <- rank(Q_Stors, ties.method="max")
rank1       <- max(rank1)-rank1
exceedtime1 <- 100 * (rank1 / (length(Q_Stors)+1))
Flow_exceeded1=sort(exceedtime1, decreasing=T)
Flow1=sort(Q_Stors)
Skal=cbind(Flow_exceeded1,Flow1)

#par(mfrow=c(1,1))

plot(true, col="black", type="l",lwd=4, main="Varighetskurve for Storselva", ylab="Q [m3/s]", xlab="% i tid oversteget", log="y")
lines(Skal, col="red", lwd=2)

legend("topright", legend = c("Sann Q Storselva","Skalert med Embrethlen"), col=c("black","red"), pch=1, cex=1)

NSeff(true,Skal)

## Verdier  sammenligne. Hvor er middelvannfringen p varighetskurven?
##              Slukeevne=2*Qmiddel. Hvor stor er den?
##              Lavvannsverdier. F.eks. 5-persentil.
# Fem-persentil sammenligning
fempers=true[which(abs(true[,1]-95)==min(abs(true[,1]-95)))]
true[true[,1]==fempers]
fempers=Skal[which(abs(Skal[,1]-95)==min(abs(Skal[,1]-95)))]
Skal[Skal[,1]==fempers]


# Qmiddel sammenligning
# Sann Qmiddel
Qm=sum(Stors)/length(Stors)
Qm_2=sum(Q_Stors)/length(Q_Stors)

# Slukeevne er dobbel Qmiddel. Finne hvilken persentil denne svarer til.
abdu=true[which(abs(true[,2]-(2*Qm_2))==min(abs(true[,2]-(2*Qm_2))))]
Q_sluk_true=true[true[,1]==abdu]


#############################SANDVASSELVA##################################
#Sandvasselva
Sand=read.table("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/Data fra NTE/Q/Q-Sandvass11-12.txt",skip=1)
Sand=Sand[,3]
Sand=as.ts(Sand)

#Sandvasselva skaleres med yungen, data fra 23.6.2011=34873 til 31.12.2012=35430

Q_Sand=((15*58.2)/(239.7*50.6))*Q[34873:35430,20]
#Sandvasselva fr Stordalsvatn som skaleringsstasjon etter OK og OcK. Stordalsvatn har data frem til 34000
#Nest best er (23) Krinsvatn
#Q_Sand_OcK=((15*58.2)/(226*49.2))*Q[29100:34200,21]
Q_Sand_OcK=((15*58.2)/(206.3*63.8))*Q[34873:35430,23]


#
Q_Sand=as.ts(Q_Sand)

#
Q_Sand_OcK=as.ts(Q_Sand_OcK)

#Q_Vlset_OcK2=as.ts(Q_Vlset_OcK2)


par(mfrow=c(1,1))
ts.plot(Sand, Q_Sand, Q_Sand_OcK, gpars=list(col=1:3),main="Sandvasselva", ylab="Q [m3/s]", xlab="Dgn fra 23.6.2011")
legend("topleft", legend = c("Sandvasselva","Skalert med yungen", "OcK: Skalert med Krinsvatn"), col=1:3, pch=1, cex=1)
library(topmodel)
NSeff(Sand,Q_Sand)
NSeff(Sand,Q_Sand_OcK)

write.table(cbind(Sand,Q_Sand,Q_Sand_OcK), file = paste("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Resultater/Skalering/","Sandvasselva.txt",sep=""),quote =FALSE, sep = ",", col.names = c("Sandvasselva","Skalert med yungen", "OcK: Skalert med Krinsvatn"))

Sand_r=as.ts(Sand[194:558])
Q_Sand_r=as.ts(Q_Sand[194:558])
Q_Sand_OcK_r=as.ts(Q_Sand_OcK[194:558])
#fdc_Ekorn=fdc(Ekorn)
#fdc_trad=fdc(Q_Ekorn)
#fdc_OcK=fdc(Q_Ekorn_OcK)
##############################################################################
rank       <- rank(Sand, ties.method="max")
rank       <- max(rank)-rank
exceedtime <- 100 * (rank / (length(Sand)+1))
Flow_exceeded=sort(exceedtime, decreasing=T)
Flow=sort(Sand)
true=cbind(Flow_exceeded,Flow)

rank1       <- rank(Q_Sand, ties.method="max")
rank1       <- max(rank1)-rank1
exceedtime1 <- 100 * (rank1 / (length(Q_Sand)+1))
Flow_exceeded1=sort(exceedtime1, decreasing=T)
Flow1=sort(Q_Sand)
Skal=cbind(Flow_exceeded1,Flow1)

rank2       <- rank(Q_Sand_OcK, ties.method="max")
rank2       <- max(rank2)-rank2
exceedtime2 <- 100 * (rank2 / (length(Q_Sand_OcK)+1))
Flow_exceeded2=sort(exceedtime2, decreasing=T)
Flow2=sort(Q_Sand_OcK)
OcK=cbind(Flow_exceeded2,Flow2)

#par(mfrow=c(1,1))

plot(true, col="black", type="l",lwd=4, main="Varighetskurve for Sandvasselva", ylab="Q [m3/s]", xlab="% i tid oversteget", log="y")
lines(Skal, col="red", lwd=2)
#lines(OK, col="green", lwd=2)
lines(OcK, col="blue", lwd=2)
legend("topright", legend = c("Sann Q Sandvasselva","Skalert med yungen","OcK: Skalert med Krinsvatn"), col=c("black","red","blue"), pch=1, cex=1)

NSeff(true,Skal)
NSeff(true,OcK)
## Verdier  sammenligne. Hvor er middelvannfringen p varighetskurven?
##              Slukeevne=2*Qmiddel. Hvor stor er den?
##              Lavvannsverdier. F.eks. 5-persentil.
# Fem-persentil sammenligning
fempers=true[which(abs(true[,1]-95)==min(abs(true[,1]-95)))]
true[true[,1]==fempers]
fempers=Skal[which(abs(Skal[,1]-95)==min(abs(Skal[,1]-95)))]
Skal[Skal[,1]==fempers]
fempers=OcK[which(abs(OcK[,1]-95)==min(abs(OcK[,1]-95)))]
OcK[OcK[,1]==fempers]

# Qmiddel sammenligning
# Sann Qmiddel
Qm=sum(Sand)/length(Sand)
Qm_2=sum(Q_Sand)/length(Q_Sand)
Qm_4=sum(Q_Sand_OcK)/length(Q_Sand_OcK)

# Slukeevne er dobbel Qmiddel. Finne hvilken persentil denne svarer til.
abdu=true[which(abs(true[,2]-(2*Qm))==min(abs(true[,2]-(2*Qm))))]
Q_sluk_true=true[true[,1]==abdu]

acc_Sand=cumsum(Sand*(54/625))
acc_Q_Sand=cumsum(Q_Sand*(54/625))
acc_Q_Sand_OcK=cumsum(Q_Sand_OcK*(54/625))
plot(acc_Sand, type="l", ylab="Akkumulert vannmengde [mill. m3]", xlab="Dager fra 23.6.2011")
lines(acc_Q_Sand, col="red")
lines(acc_Q_Sand_OcK, col="green")
legend("bottomright", legend = c("Sann Q Sandvasselva","Skalert med yungen","OcK: Skalert med Krinsvatn"), col=c("black","red","blue"), pch=1, cex=1)

# For akkumulert differanse
plot(as.ts(acc_Q_Sand_OcK-acc_Sand))
lines(as.ts(acc_Q_Sand-acc_Sand))

#######################################NAVLUSFOSS#################################
#Navlusfoss
rm(list=ls())
Navlus=read.table("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/Data fra NTE/Q/NavlusQ09-12.txt",skip=1)
Navlus=Navlus[,3]
Navlus=as.ts(Navlus)

#Navlusfoss skaleres med Embrethlen

Q_Navlus=((434.1*28)/(494.3*40.6))*Q[34213:35430,18]
#Gjelder ogs etter OK og OcK
Q_Navlus=as.ts(Q_Navlus)


par(mfrow=c(1,1))
ts.plot(Navlus, Q_Navlus,gpars=list(col=1:2),main="Navlusfoss", ylab="Q [m3/s]", xlab="Dgn fra 1.9.2009")
legend("topleft", legend = c("Navlusfoss","Skalert med Embrethlen"), col=1:2, pch=1, cex=1)
library(topmodel)
NSeff(Navlus,Q_Navlus)

write.table(cbind(Navlus,Q_Navlus), file = paste("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Resultater/Skalering/","Navlus.txt",sep=""),quote =FALSE, sep = ",", col.names = c("Storselva","Skalert med Embrethlen"))

Navlus_r=as.ts(Navlus[853:1218])
Q_Navlus_r=as.ts(Q_Navlus[853:1218])

#fdc_Ekorn=fdc(Ekorn)
#fdc_trad=fdc(Q_Ekorn)
#fdc_OcK=fdc(Q_Ekorn_OcK)
##############################################################################
rank       <- rank(Navlus, ties.method="max")
rank       <- max(rank)-rank
exceedtime <- 100 * (rank / (length(Navlus)+1))
Flow_exceeded=sort(exceedtime, decreasing=T)
Flow=sort(Navlus)
true=cbind(Flow_exceeded,Flow)

rank1       <- rank(Q_Navlus, ties.method="max")
rank1       <- max(rank1)-rank1
exceedtime1 <- 100 * (rank1 / (length(Q_Navlus)+1))
Flow_exceeded1=sort(exceedtime1, decreasing=T)
Flow1=sort(Q_Navlus)
Skal=cbind(Flow_exceeded1,Flow1)

#par(mfrow=c(1,1))

plot(true, col="black", type="l",lwd=4, main="Varighetskurve for Navlusfoss", ylab="Q [m3/s]", xlab="% i tid oversteget", log="y")
lines(Skal, col="red", lwd=2)

legend("topright", legend = c("Sann Q Navlusfoss","Skalert med Embrethlen"), col=c("black","red"), pch=1, cex=1)

NSeff(true,Skal)

## Verdier  sammenligne. Hvor er middelvannfringen p varighetskurven?
##              Slukeevne=2*Qmiddel. Hvor stor er den?
##              Lavvannsverdier. F.eks. 5-persentil.
# Fem-persentil sammenligning
fempers=true[which(abs(true[,1]-95)==min(abs(true[,1]-95)))]
true[true[,1]==fempers]
fempers=Skal[which(abs(Skal[,1]-95)==min(abs(Skal[,1]-95)))]
Skal[Skal[,1]==fempers]


# Qmiddel sammenligning
# Sann Qmiddel
Qm=sum(Navlus)/length(Navlus)
Qm_2=sum(Q_Navlus)/length(Q_Navlus)

# Slukeevne er dobbel Qmiddel. Finne hvilken persentil denne svarer til.
abdu=true[which(abs(true[,2]-(2*Qm_2))==min(abs(true[,2]-(2*Qm_2))))]
Q_sluk_true=true[true[,1]==abdu]

######################HELLIFOSS############################
#Hellifoss

rm(list=ls())
Helli=read.table("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/Data fra NTE/Q/hellifossQ08-11.txt",skip=1)
Helli=Helli[,3]
Helli=as.ts(Helli)

#Hellifoss skaleres med Frste Aunvatn, data fra 1.1.2008=33604 til 31.12.2011=35064
#Gjelder ogs etter OK og OcK
Q_Helli=((60.6*84)/(87.6*110.7))*Q[33604:35064,10] # serien starter 24450-
Q_Helli=as.ts(Q_Helli)


par(mfrow=c(1,1))
ts.plot(Helli, Q_Helli,gpars=list(col=1:2),main="Hellifoss", ylab="Q [m3/s]", xlab="Dgn fra 1.9.2008")
legend("topleft", legend = c("Hellifoss","Skalert med Frste Aunvatn"), col=1:2, pch=1, cex=1)
library(topmodel)
NSeff(Helli,Q_Helli)

write.table(cbind(Helli,Q_Helli), file = paste("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Resultater/Skalering/","Hellifoss.txt",sep=""),quote =FALSE, sep = ",", col.names = c("Hellifoss","Skalert med Frste Aunvatn"))

#2009 er medianret
Helli_r=as.ts(Helli[123:487])
Q_Helli_r=as.ts(Q_Helli[123:487])

#fdc_Ekorn=fdc(Ekorn)
#fdc_trad=fdc(Q_Ekorn)
#fdc_OcK=fdc(Q_Ekorn_OcK)
##############################################################################
rank       <- rank(Helli, ties.method="max")
rank       <- max(rank)-rank
exceedtime <- 100 * (rank / (length(Helli)+1))
Flow_exceeded=sort(exceedtime, decreasing=T)
Flow=sort(Helli)
true=cbind(Flow_exceeded,Flow)

rank1       <- rank(Q_Helli, ties.method="max")
rank1       <- max(rank1)-rank1
exceedtime1 <- 100 * (rank1 / (length(Q_Helli)+1))
Flow_exceeded1=sort(exceedtime1, decreasing=T)
Flow1=sort(Q_Helli)
Skal=cbind(Flow_exceeded1,Flow1)

#par(mfrow=c(1,1))

plot(true, col="black", type="l",lwd=4, main="Varighetskurve for Hellifoss", ylab="Q [m3/s]", xlab="% i tid oversteget", log="y")
lines(Skal, col="red", lwd=2)

legend("topright", legend = c("Sann Q Hellifoss","Skalert med Frste Aunvatn"), col=c("black","red"), pch=1, cex=1)

NSeff(true,Skal)

## Verdier  sammenligne. Hvor er middelvannfringen p varighetskurven?
##              Slukeevne=2*Qmiddel. Hvor stor er den?
##              Lavvannsverdier. F.eks. 5-persentil.
# Fem-persentil sammenligning
fempers=true[which(abs(true[,1]-95)==min(abs(true[,1]-95)))]
true[true[,1]==fempers]
fempers=Skal[which(abs(Skal[,1]-95)==min(abs(Skal[,1]-95)))]
Skal[Skal[,1]==fempers]


# Qmiddel sammenligning
# Sann Qmiddel
Qm=sum(Helli)/length(Helli)
Qm_2=sum(Q_Helli)/length(Q_Helli)

# Slukeevne er dobbel Qmiddel. Finne hvilken persentil denne svarer til.
abdu=true[which(abs(true[,2]-(2*Qm_2))==min(abs(true[,2]-(2*Qm_2))))]
Q_sluk_true=true[true[,1]==abdu]

##########################FLTTADAL#######################



#Sandvasselva
Fltt=read.table#("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/Data fra NTE/Q/Q-Sandvass11-12.txt",skip=1)
Fltt=Fltt[,3]
Fltt=as.ts(Fltt)

#Flttadal skaleres med Moen

Q_Fltt=((119.7*84.7)/(63.9*61.6))*Q[33604:35430,9]

# Gjelder ogs etter OK, men fr Mannseter som skaleringsstasjon etter OcK

Q_Fltt_OcK=((119.7*84.7)/(96.8*38.8))*Q[33604:35430,33]

#
Q_Fltt=as.ts(Q_Fltt)

#
Q_Fltt_OcK=as.ts(Q_Fltt_OcK)

#Q_Vlset_OcK2=as.ts(Q_Vlset_OcK2)


par(mfrow=c(1,1))
ts.plot(Sand, Q_Sand, Q_Sand_OcK, gpars=list(col=1:3),main="Sandvasselva", ylab="Q [m3/s]", xlab="Dgn fra 23.6.2011")
legend("topleft", legend = c("Sandvasselva","Skalert med yungen", "OcK: Skalert med Krinsvatn"), col=1:3, pch=1, cex=1)
library(topmodel)
NSeff(Sand,Q_Sand)
NSeff(Sand,Q_Sand_OcK)

write.table(cbind(Sand,Q_Sand,Q_Sand_OcK), file = paste("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Resultater/Skalering/","Sandvasselva.txt",sep=""),quote =FALSE, sep = ",", col.names = c("Sandvasselva","Skalert med yungen", "OcK: Skalert med Krinsvatn"))

Sand_r=as.ts(Sand[194:558])
Q_Sand_r=as.ts(Q_Sand[194:558])
Q_Sand_OcK_r=as.ts(Q_Sand_OcK[194:558])
#fdc_Ekorn=fdc(Ekorn)
#fdc_trad=fdc(Q_Ekorn)
#fdc_OcK=fdc(Q_Ekorn_OcK)
##############################################################################
rank       <- rank(Sand, ties.method="max")
rank       <- max(rank)-rank
exceedtime <- 100 * (rank / (length(Sand)+1))
Flow_exceeded=sort(exceedtime, decreasing=T)
Flow=sort(Sand)
true=cbind(Flow_exceeded,Flow)

rank1       <- rank(Q_Sand, ties.method="max")
rank1       <- max(rank1)-rank1
exceedtime1 <- 100 * (rank1 / (length(Q_Sand)+1))
Flow_exceeded1=sort(exceedtime1, decreasing=T)
Flow1=sort(Q_Sand)
Skal=cbind(Flow_exceeded1,Flow1)

rank2       <- rank(Q_Sand_OcK, ties.method="max")
rank2       <- max(rank2)-rank2
exceedtime2 <- 100 * (rank2 / (length(Q_Sand_OcK)+1))
Flow_exceeded2=sort(exceedtime2, decreasing=T)
Flow2=sort(Q_Sand_OcK)
OcK=cbind(Flow_exceeded2,Flow2)

#par(mfrow=c(1,1))

plot(true, col="black", type="l",lwd=4, main="Varighetskurve for Sandvasselva", ylab="Q [m3/s]", xlab="% i tid oversteget", log="y")
lines(Skal, col="red", lwd=2)
#lines(OK, col="green", lwd=2)
lines(OcK, col="blue", lwd=2)
legend("topright", legend = c("Sann Q Sandvasselva","Skalert med yungen","OcK: Skalert med Krinsvatn"), col=c("black","red","blue"), pch=1, cex=1)

NSeff(true,Skal)
NSeff(true,OcK)
## Verdier  sammenligne. Hvor er middelvannfringen p varighetskurven?
##              Slukeevne=2*Qmiddel. Hvor stor er den?
##              Lavvannsverdier. F.eks. 5-persentil.
# Fem-persentil sammenligning
fempers=true[which(abs(true[,1]-95)==min(abs(true[,1]-95)))]
true[true[,1]==fempers]
fempers=Skal[which(abs(Skal[,1]-95)==min(abs(Skal[,1]-95)))]
Skal[Skal[,1]==fempers]
fempers=OcK[which(abs(OcK[,1]-95)==min(abs(OcK[,1]-95)))]
OcK[OcK[,1]==fempers]

# Qmiddel sammenligning
# Sann Qmiddel
Qm=sum(Sand)/length(Sand)
Qm_2=sum(Q_Sand)/length(Q_Sand)
Qm_4=sum(Q_Sand_OcK)/length(Q_Sand_OcK)

# Slukeevne er dobbel Qmiddel. Finne hvilken persentil denne svarer til.
abdu=true[which(abs(true[,2]-(2*Qm))==min(abs(true[,2]-(2*Qm))))]
Q_sluk_true=true[true[,1]==abdu]

acc_Sand=cumsum(Sand*(54/625))
acc_Q_Sand=cumsum(Q_Sand*(54/625))
acc_Q_Sand_OcK=cumsum(Q_Sand_OcK*(54/625))
plot(acc_Sand, type="l", ylab="Akkumulert vannmengde [mill. m3]", xlab="Dager fra 23.6.2011")
lines(acc_Q_Sand, col="red")
lines(acc_Q_Sand_OcK, col="green")
legend("bottomright", legend = c("Sann Q Sandvasselva","Skalert med yungen","OcK: Skalert med Krinsvatn"), col=c("black","red","blue"), pch=1, cex=1)

# For akkumulert differanse
plot(as.ts(acc_Q_Sand_OcK-acc_Sand))
lines(as.ts(acc_Q_Sand-acc_Sand))

#################BLA#####################
#bla


rm(list=ls())
Bla=read.table("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/Data fra NTE/Q/BolaQ09-12.txt",skip=1)
Bla=Bla[,3]
Bla=as.ts(Bla)

#Skalering fra 1.1.2008 til 31.12.2012. 1.1.2000 = 30682
# Bla skaleres med Stafoss (22)
# Bla fr ogs Stafoss som skaleringsstasjon etter OK og OcK

Q_Bla=((45.1*33.8)/(477*36.5))*Q[33970:35430,22]
Q_Bla=as.ts(Q_Bla)

par(mfrow=c(1,1))
ts.plot(Bla, Q_Bla,gpars=list(col=1:2),main="Bla", ylab="Q [m3/s]", xlab="Dgn fra 1.1.2009")
legend("topleft", legend = c("Bla","Skalert med Stafoss"), col=1:2, pch=1, cex=1)
library(topmodel)
NSeff(Bla,Q_Bla)

write.table(cbind(Bla,Q_Bla), file = paste("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Resultater/Skalering/","Bla.txt",sep=""),quote =FALSE, sep = ",", col.names = c("Bla","Skalert med Stafoss"))

#Medianret er 2012, 1096:1461
Bla_r=as.ts(Bla[1096:1461])
Q_Bla_r=as.ts(Q_Bla[1096:1461])


#fdc_Ekorn=fdc(Ekorn)
#fdc_trad=fdc(Q_Ekorn)
#fdc_OcK=fdc(Q_Ekorn_OcK)
##############################################################################
rank       <- rank(Bla, ties.method="max")
rank       <- max(rank)-rank
exceedtime <- 100 * (rank / (length(Bla)+1))
Flow_exceeded=sort(exceedtime, decreasing=T)
Flow=sort(Bla)
true=cbind(Flow_exceeded,Flow)

rank1       <- rank(Q_Bla, ties.method="max")
rank1       <- max(rank1)-rank1
exceedtime1 <- 100 * (rank1 / (length(Q_Bla)+1))
Flow_exceeded1=sort(exceedtime1, decreasing=T)
Flow1=sort(Q_Bla)
Skal=cbind(Flow_exceeded1,Flow1)

#par(mfrow=c(1,1))

plot(true, col="black", type="l",lwd=4, main="Varighetskurve for Bla", ylab="Q [m3/s]", xlab="% i tid oversteget", log="y")
lines(Skal, col="red", lwd=2)

legend("topright", legend = c("Sann Q Bla","Skalert med Stafoss"), col=c("black","red"), pch=1, cex=1)

NSeff(true,Skal)

## Verdier  sammenligne. Hvor er middelvannfringen p varighetskurven?
##              Slukeevne=2*Qmiddel. Hvor stor er den?
##              Lavvannsverdier. F.eks. 5-persentil.
# Fem-persentil sammenligning
fempers=true[which(abs(true[,1]-95)==min(abs(true[,1]-95)))]
true[true[,1]==fempers]
fempers=Skal[which(abs(Skal[,1]-95)==min(abs(Skal[,1]-95)))]
Skal[Skal[,1]==fempers]


# Qmiddel sammenligning
# Sann Qmiddel
Qm=sum(Bla)/length(Bla)
Qm_2=sum(Q_Bla)/length(Q_Bla)

# Slukeevne er dobbel Qmiddel. Finne hvilken persentil denne svarer til.
abdu=true[which(abs(true[,2]-(2*Qm_2))==min(abs(true[,2]-(2*Qm_2))))]
Q_sluk_true=true[true[,1]==abdu]