##
## Erlend april 2014 - PET_WI.r
## Utregning av PET og deretter WI for alle felt
## Original: Mulugeta B. Zelelew, NTNU
# =============================================================
#
# Setter arbeidskatalog og tar inn R-pakkene som trengs

library("hydroTSM")
library(fields)
library(SPEI)
library(zoo)       
setwd( "C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/WI")

# Leser inn data fra scriptet Klimadata_for_felt.r
# Daglige data for alle nedbrsfelt
daily.temp <- read.table("temp.out",header =TRUE, sep ="")
names(daily.temp) <- paste("Catch_",seq(0,56,1), sep="") 

daily.precip <- read.table("precip.out",header =TRUE, sep ="")
names(daily.precip) <- paste("Catch_",seq(0,56,1), sep="")

# Ta vare p datoene for dataene for strukturering
#daily.tp.date <- as.Date(daily.temp[,1],"%d-%m-%YYY")
daily.tp.date = as.Date(row.names(daily.temp), "%d-%m-%Y")

# Strukturerer data som daglig tisdataserie
daily.temp.zoo <- zoo(daily.temp, daily.tp.date)
daily.precip.zoo <- zoo(daily.precip, daily.tp.date)

# Gjr om til mnedlige verdier. Snitt av temperatur og akkumulert nedbr.
temp.monthly <- daily2monthly(daily.temp.zoo, FUN=mean, na.rm=TRUE)
precip.monthly <- daily2monthly(daily.precip.zoo, FUN=sum, na.rm=TRUE)
  
# Trenger bredddegrad for utregning av PET.
catch.coords <- read.table("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/Alle felt.txt",header =TRUE, sep ="")
catch.latitude <- catch.coords[,6]
catch_name <- names(temp.monthly)

# Regner ut mnedlige verdier for PET ved funksjonen thornthwaite. Skriver filer med 
# mnedlige fordampings-(PET) og nedbrsverdier.
Catch.num <- ncol(temp.monthly)
for (i in 1:Catch.num){
  #Next.catch <- i
  PET.tho <- thornthwaite(temp.monthly[,i],catch.latitude[i]) 
  PET_out <- as.data.frame(zoo(PET.tho, time(temp.monthly)))
  #names(PET_out) <- c("Date","PET_tho")
  #
  monthly_precip <- zoo(precip.monthly[,i], time(temp.monthly[,i]))
  
  write.table(PET_out, paste("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/WI/thorn_data/PET/",catch_name[i],".out",sep=""),quote = FALSE, col.names=FALSE)
  write.table(monthly_precip, paste("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/WI/thorn_data/Precip/",catch_name[i],".prc",sep=""),quote = FALSE, col.names=FALSE)
  
}
#
# Kodene under gjr om fordampings- og nedbrsverdier fra mnedlige data til rlige data.
output <- "PET_annual.txt"
output2 <- "PRECIP_annual.txt"
fout <- file(output, "w")
fout2 <- file(output2, "w")
#
PET_files<- list.files("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/WI/thorn_data/PET/", pattern ="*.out")#, all.files = TRUE,full.names = TRUE)
Precip_files<- list.files("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/WI/thorn_data/Precip/", pattern ="*.prc")#, all.files = TRUE,full.names = TRUE)
#PET_files_1 <- PET_files[1]
nc <- length(PET_files)
for (j in 1:nc){
  Next_PET_file <- read.table(paste("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/WI/thorn_data/PET/",PET_files[j],sep=""), header=FALSE)
  PET_next <- zoo(Next_PET_file[,2], time(temp.monthly))
  daily2annual1 <- monthly2annual(PET_next,FUN=sum, na.rm=TRUE)
  annual_average <- mean(daily2annual1)
  cat(paste(c(PET_files[j], annual_average)), file =fout)
  cat("\n",file=fout)
  
  #
  Next_PRECIP_file <- read.table(paste("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/WI/thorn_data/Precip/",Precip_files[j],sep=""), header=FALSE)
  PRECIP_next <- zoo(Next_PRECIP_file[,2], time(temp.monthly))
  daily2annual2 <- monthly2annual(PRECIP_next,FUN=sum, na.rm=TRUE)
  annual_average2 <- mean(daily2annual2)
  cat(paste(c(Precip_files[j], annual_average2)), file =fout2)
  cat("\n",file=fout2)
}
closeAllConnections()


# Tar inn de rlige verdiene og regner ut WI p dette grunnlaget og skriver til fil.
output3 = "WI.txt"
fout3 <- file(output3, "w")
PET=read.table("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/WI/PET_annual.txt")
Precip=read.table("C:/Users/Erlend/Documents/NTNU/Masteroppgave/Data/WI/PRECIP_annual.txt")
for (j in 1:nrow(PET)){
  WI=(Precip[j,2])/(PET[j,2])
  cat(paste(c(PET_files[j], WI)), file =fout3)
  cat("\n",file=fout)
}
closeAllConnections()